#include-once
#include <GUIT.au3>
#include <Array.au3>
#include <SendMessage.au3>
#include <GDIP.au3>
#include <Misc.au3>
#include <Memory.au3>




Global $structs[1],$firstused=0
Global $minb=0,$clob=0
OnAutoItExitRegister("__AeroExDis")
AdlibRegister("__AeroProc",20)




Func _AeroCreate($title="",$width=400,$height=400,$iconimg="",$round=1,$argbcolor="0x77AAAAAA",$style=$WS_SYSMENU,$exstyle=0,$parent=0)
	If $minb=0 Then $minb=_LoadImage("_IMG_Minimize")
	If $clob=0 Then $clob=_LoadImage("_IMG_Close")
	$height+=40
	If $firstused=0 Then
		$firstused=1
		Local $gui=_CreateGUIT($title,$width,$height,$style,$exstyle,$parent)
		$iconimg=_LoadIoI($iconimg)
		$structs[0]=__AeroStructCreate($gui,$iconimg,$title,$round,$argbcolor)
	Else
		Local $gui=_CreateGUIT($title,$width,$height,$style,$exstyle,$parent)
		$iconimg=_LoadIoI($iconimg)
		_ArrayAdd($structs,__AeroStructCreate($gui,$iconimg,$title,$round,$argbcolor))
	EndIf
	__AeroRedraw($structs[UBound($structs,1)-1])
	Return $gui[5] ;Backbuffer, damit man selber weiterzeichnen kann
EndFunc

Func _AeroSetTrans($backgra,$alpha)
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $info=__AeroStructGetInfo($structs[$num])
	Local $gui=__AeroStructGetGUI($structs[$num])
	Local $Var__tBlend = DllStructCreate($tagBLENDFUNCTION,$gui[8])
    DllStructSetData($Var__tBlend, "Alpha", $alpha)
    DllStructSetData($Var__tBlend, "Format", 1)
	$gui[8]=DllStructGetPtr($Var__tBlend)
	$structs[$num]=__AeroStructCreate($gui,$info[0],$info[1],$info[2],$info[3])
	_AeroUpdate($backgra,$info[2])
EndFunc

Func _AeroDrawImage($backgra,$image,$x=0,$y=0,$w=-1,$h=-1)
	If $image=0 Then Return
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $info=__AeroStructGetInfo($structs[$num])
	If $w=-1 Then $w=_GDIPlus_ImageGetWidth($image)
	If $h=-1 Then $h=_GDIPlus_ImageGetHeight($image)
	_GDIPlus_GraphicsDrawImageRect($backgra,$image,$x,$y,$w,$h)
	Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
	_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
	_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
	_GDIPlus_BrushDispose($brush)
	_AeroUpdate($backgra,$info[2])
EndFunc

Func _AeroFillImage($backgra,$image)
	If $image=0 Then Return
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $info=__AeroStructGetInfo($structs[$num])
	Local $gui=__AeroStructGetGUI($structs[$num])
	Local $si[2]
	Local $size=DllStructCreate($tagSIZE,$gui[6])
	$si[0]=DllStructGetData($size,1)
	$si[1]=DllStructGetData($size,2)
	Local $b=_GDIPlus_TextureCreate($image)
	_GDIPlus_GraphicsFillRect($backgra,0,0,$si[0],$si[1],$b)
	_GDIPlus_BrushDispose($b)
	Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
	_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
	_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
	_GDIPlus_BrushDispose($brush)
	_AeroUpdate($backgra,$info[2])
EndFunc

Func _AeroBgImage($backgra,$image)
	If $image=0 Then Return
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $info=__AeroStructGetInfo($structs[$num])
	Local $gui=__AeroStructGetGUI($structs[$num])
	Local $si[2]
	Local $size=DllStructCreate($tagSIZE,$gui[6])
	$si[0]=DllStructGetData($size,1)
	$si[1]=DllStructGetData($size,2)
	Local $b=_GDIPlus_TextureCreate($image)
	_GDIPlus_GraphicsClear($backgra,"0x00000000")
	_GDIPlus_GraphicsFillRect($backgra,0,0,$si[0],$si[1],$b)
	_GDIPlus_BrushDispose($b)
	Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
	_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
	_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
	_GDIPlus_BrushDispose($brush)
	_AeroUpdate($backgra,$info[2])
EndFunc

Func _AeroGetSize($backgra)
	Local $si[2]
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	Local $size=DllStructCreate($tagSIZE,$gui[6])
	$si[0]=DllStructGetData($size,1)
	$si[1]=DllStructGetData($size,2)
	Return $si
EndFunc

Func _AeroSetIcon($backgra,$img)
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $info=__AeroStructGetInfo($structs[$num])
	_GDIPlus_ImageDispose($info[0])
	$info[0]=_LoadIoI($img)
	DllStructSetData($structs[$num],"Icon",$info[0])
EndFunc

Func _AeroMove($backgra,$x,$y)
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	WinMove($gui[0],"",$x,$y)
EndFunc

Func _AeroSetState($backgra,$state=@SW_SHOW)
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	GUISetState($state,$gui[0])
EndFunc

Func _AeroSetTitle($backgra,$newtitle="")
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	Local $info=__AeroStructGetInfo($struct)
	WinSetTitle($gui[0],"",$newtitle)
	$info[1]=$newtitle
	$structs[$num]=__AeroStructCreate($gui,$info[0],$info[1],$info[2],$info[3])
	__AeroRedraw($structs[$num])
EndFunc

Func _AeroWorkAreaCreate($backgra,$x,$y,$w,$h,$state=@SW_SHOW) ;fr GUI Buttons
    Local $num=__AeroGet($backgra)
    If $num=-1 Then Return
    Local $struct=$structs[$num]
    Local $gui=__AeroStructGetGUI($struct)
    Local $xy=WinGetPos($gui[0])
    $x+=4 ;MDICHILDverschiebung
    $y+=25+3 ;MDICHILDverschiebung
    Local $wh=WinGetClientSize($gui[0])
    If $x+$w>$xy[0]+$wh[0] Then $w=$x-$xy[0]+$wh[0]
    If $y+$h>$xy[1]+$wh[1]-65 Then $h=$y-$xy[1]+$wh[1]-65 ;40 Rand unten, 25 Rand oben
    Local $hwnd=GUICreate("",$w-1,$h,$x,$y,$WS_POPUP,$WS_EX_MDICHILD,$gui[0])
    GUISetState($state,$hwnd)
    Return $hwnd
EndFunc

Func _AeroWorkAreaMove($WArea,$x,$y,$w=-1,$h=-1)
    Local $gui=DllCall("user32.dll","hwnd","GetParent","hwnd",$WArea)
    If Not IsArray($gui) Then Return
    Local $cs=WinGetClientSize($WArea)
    If $w=-1 Then $w=$cs[0]
    If $h=-1 Then $h=$cs[1]
    Local $xy=WinGetPos($gui[0])
    $x+=$xy[0]
    $y+=25+$xy[1]
    Local $wh=WinGetClientSize($gui[0])
    If $x+$w>$xy[0]+$wh[0] Then $w=$x-$xy[0]+$wh[0]
    If $y+$h>$xy[1]+$wh[1]-65 Then $h=$y-$xy[1]+$wh[1]-65 ;40 Rand unten, 25 Rand oben
    WinMove($WArea,"",$x,$y,$w,$h)
EndFunc

Func _AeroWorkAreaSetState($workareahwnd,$state)
	GUISetState($state,$workareahwnd)
EndFunc

Func _AeroWorkAreaDelete($workareahwnd)
	GUIDelete($workareahwnd)
EndFunc

Func __AeroProc()
	Local $s,$gui,$size,$w,$h,$pos,$info
	For $x=0 To UBound($structs,1)-1
		$s=$structs[$x]
		$gui=__AeroStructGetGUI($s)
		$info=__AeroStructGetInfo($s)
		If Not BitAND(WinGetState($gui[0]),2) Then ContinueLoop ;to see
		$size=DllStructCreate($tagSIZE,$gui[6])
		$w=DllStructGetData($size,1)
		$h=DllStructGetData($size,2)
		__AeroDrawWinButtons($gui[5],$w,$h,$info,$gui)
		_AeroUpdate($gui[5],$info[2])
		$pos=MouseGetPos()
		$wpos=WinGetPos($gui[0])
		$wasin=0
		$pt=_NewPoint($pos[0],$pos[1])
		$rect=_NewRect($wpos[0]+$w-50,$wpos[1],43,17)
		If _WinAPI_PtInRect($rect,$pt) Then
			If _IsPressed("1") Then _SendMessage($gui[0],$WM_CLOSE)
			$wasin=1
		EndIf
		$rect=_NewRect($wpos[0]+$w-74,$wpos[1],24,17)
		If _WinAPI_PtInRect($rect,$pt) Then
			If _IsPressed("1") Then GUISetState(@SW_MINIMIZE,$gui[0])
			$wasin=1
		EndIf
		$rect=_NewRect($wpos[0],$wpos[1],$w,25)
		If _WinAPI_PtInRect($rect,$pt) And $wasin=0 Then
			If BitAND(WinGetState($gui[0]),8) Then ;Active
				$diffx=$pos[0]-$wpos[0]
				$diffy=$pos[1]-$wpos[1]
				While _IsPressed("1")
					$pos=MouseGetPos()
					WinMove($gui[0],"",$pos[0]-$diffx,$pos[1]-$diffy)
					Sleep(10)
				WEnd
			EndIf
		EndIf
		$pt=0
		$rect=0
		$orect=0
	Next
EndFunc

Func _AeroUpdate($backgra,$round=0) ; Damit man auch selber etwas zeichnen kann
	If $round=1 Then
		_AeroUpdateRound($backgra)
		Return
	EndIf
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	_DrawonGUIT($gui)
EndFunc

Func __AeroRedraw($aerostruct)
	Local $gui=__AeroStructGetGUI($aerostruct)
	Local $info=__AeroStructGetInfo($aerostruct)
	Local $backgra=$gui[5]
	Local $size=DllStructCreate($tagSIZE,$gui[6])
	Local $w=DllStructGetData($size,1)
	Local $h=DllStructGetData($size,2)
	Local $brush=_GDIPlus_BrushCreateSolid($info[3])
	_GDIPlus_GraphicsClear($backgra,0x00000000)
	_GDIPlus_GraphicsFillRect($backgra,0,0,$w,$h,$brush)
	_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
	_GDIPlus_BrushSetSolidColor($brush,"0xFF000000")
	_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
	_GDIPlus_BrushDispose($brush)
	__AeroDrawWinButtons($backgra,$w,$h,$info,$gui)
	_AeroUpdate($backgra,$info[2])
EndFunc

Func __AeroDrawWinButtons($backgra,$w,$h,$info,$gui)
	;Close
	Local $point=_WinAPI_GetMousePos(True,$gui[0])
	Local $rect=_NewRect($w-50,0,43,17)
	Local $which=0
	If _WinAPI_PtInRect($rect,$point) Then
		$which=1
		If _IsPressed("1") Then $which=2
	EndIf
	_GDIPlus_GraphicsDrawImageRectRect($backgra,$clob,8,$which*33+8,44,18,$w-50,0,44,18)
	;Minimize
	Local $rect=_NewRect($w-74,0,24,17)
	Local $which=0
	If _WinAPI_PtInRect($rect,$point) Then
		$which=1
		If _IsPressed("1") Then $which=2
	EndIf
	_GDIPlus_GraphicsDrawImageRectRect($backgra,$minb,9,$which*33+8,25,18,$w-75,0,25,18)
EndFunc

Func _AeroDelete(ByRef $backgra)
	Local $ele=__AeroGet($backgra)
	If $ele=-1 Then Return
	Local $struct=$structs[$ele]
	Local $gui=__AeroStructGetGUI($struct)
	_DeleteGUIT($gui)
	Local $info=__AeroStructGetInfo($struct)
	_GDIPlus_ImageDispose($info[0])
	$struct=0
	_ArrayDelete($structs,$ele)
	$backgra=0
EndFunc

Func _AeroGetHwnd($backgra)
	Local $gui
	For $x=0 To UBound($structs,1)-1
		$gui=__AeroStructGetGUI($structs[$x])
		If $gui[5]=$backgra Then Return $gui[0]
	Next
	Return SetError(1,0,0)
EndFunc

Func __AeroGet($backgra)
	Local $gui
	For $x=0 To UBound($structs,1)-1
		$gui=__AeroStructGetGUI($structs[$x])
		If $gui[5]=$backgra Then Return $x
	Next
	Return SetError(1,0,-1)
EndFunc

Func __AeroStructGetGUI($struct)
	Local $gui[9]
	For $x=0 To 8
		$gui[$x]=DllStructGetData($struct,$x+1)
	Next
	Return $gui
EndFunc

Func __AeroStructGetInfo($struct)
	Local $info[4]
	$info[0]=DllStructGetData($struct,"Icon")
	$info[1]=DllStructGetData($struct,"title")
	$info[2]=DllStructGetData($struct,"round")
	$info[3]=DllStructGetData($struct,"argbcolor")
	Return $info
EndFunc

Func __AeroStructCreate($guiarray,$iconimg,$title,$round,$argbcolor)
	If $title="" Then $title=" "
	Local $struct=DllStructCreate("HWND GUI;HANDLE ScreenDC;HANDLE DC;HANDLE Graphics;HANDLE Buffer;HANDLE Backbuffer;ptr Size;ptr Point;ptr Blend;HANDLE Icon;CHAR title["&Int(StringLen($title))&"];int round;CHAR argbcolor[10]")
	For $x=0 To 8
		DllStructSetData($struct,$x+1,$guiarray[$x])
	Next
	DllStructSetData($struct,"Icon",$iconimg)
	DllStructSetData($struct,"title",$title)
	DllStructSetData($struct,"round",$round)
	DllStructSetData($struct,"argbcolor",$argbcolor)
	Return $struct
EndFunc

Func __AeroExDis()
	_GDIPlus_ImageDispose($minb)
	_GDIPlus_ImageDispose($clob)
	_GDIPlus_Shutdown()
EndFunc




;TheShadowAE: erstellt
Func _GDIPlus_GraphicsFillRoundRect($gra,$x,$y,$w,$h,$r=30,$brush=0)
	Local $path=_GDIPlus_PathCreate(1)
	_GDIPlus_PathAddPie($path,$x,$y,$r,$r,180,90)
	_GDIPlus_PathAddPie($path,$x+$w-$r,$y,$r,$r,270,90)
	_GDIPlus_PathAddPie($path,$x+$w-$r,$y+$h-$r,$r,$r,0,90)
	_GDIPlus_PathAddPie($path,$x,$y+$h-$r,$r,$r,90,90)
	_GDIPlus_PathAddRectangle($path,$x,$y+$r/2,$w,$h-$r)
	_GDIPlus_PathAddRectangle($path,$x+$r/2,$y,$w-$r,$h)
	_GDIPlus_PathCloseFigure($path)
	_GDIPlus_GraphicsFillPath($gra,$path,$brush)
	_GDIPlus_PathDispose($path)
EndFunc
;TheShadowAE: erstellt
Func _DrawStr($gra,$str,$x=0,$y=0,$brush=0,$size=12,$flag=0,$face="Arial")
	Local $family=_GDIPlus_FontFamilyCreate($face)
	Local $font=_GDIPlus_FontCreate($family,$size,$flag)
	_GDIPlus_FontFamilyDispose($family)
	Local $format=_GDIPlus_StringFormatCreate()
	Local $layout=_GDIPlus_RectFCreate($x,$y)
	_GDIPlus_GraphicsDrawStringEx($gra,$str,$font,$layout,$format,$brush)
	_GDIPlus_FontDispose($font)
	_GDIPlus_StringFormatDispose($format)
EndFunc
;name22: erstellt
Func _PointIsInCircle($iX_Point, $iY_Point, $iX_Circle, $iY_Circle, $iRadius_Circle)
    $iDistPoints = _GetPointsDistance($iX_Point, $iY_Point, $iX_Circle, $iY_Circle)
    If ($iRadius_Circle > 0 And $iDistPoints < $iRadius_Circle) Or ($iRadius_Circle < 0 And $iDistPoints > $iRadius_Circle) Or $iDistPoints = 0 Then Return $iDistPoints
    Return -1
EndFunc   ;==>_PointIsInCircle
Func _GetPointsDistance($iPointX1, $iPointY1, $iPointX2, $iPointY2)
    Return Sqrt(($iPointX1 - $iPointX2) ^ 2 + ($iPointY1 - $iPointY2) ^ 2)
EndFunc   ;==>_GetPointsDistance
;TheShadowAE: erstellt
Func _NewRect($x=0,$y=0,$w=0,$h=0)
	Local $struct=DllStructCreate("uint Left;uint Top;uint Right;uint Bottom");$tagRECT
	DllStructSetData($struct,"Left",$x)
	DllStructSetData($struct,"Top",$y)
	DllStructSetData($struct,"Right",$x+$w)
	DllStructSetData($struct,"Bottom",$y+$h)
	Return $struct
EndFunc
Func _NewPoint($x=0,$y=0)
	Local $struct=DllStructCreate("int x;int y");$tagPOINT
	DllStructSetData($struct,"x",$x)
	DllStructSetData($struct,"y",$y)
	Return $struct
EndFunc
Func _LoadIoI($datei)
	If _GetFileExt($datei)="ico" Then
		Local $hico=_ExtractIcon($datei,0,0)
		Local $bmp=_GDIPlus_BitmapCreateFromHICON($hico)
		_WinAPI_DeleteObject($hico)
		Return $bmp
	Else
		Return _GDIPlus_ImageLoadFromFile($datei)
	EndIf
EndFunc
Func _ExtractIcon($file,$index=0,$mode=1)
	;Author: TheShadowAE
	Local $icon=DllStructCreate("ptr")
	Local $picon=DllStructGetPtr($icon,1)
	If $mode=1 Then
		_WinAPI_ExtractIconEx($file,$index,$picon,0,1)
	Else
		_WinAPI_ExtractIconEx($file,$index,0,$picon,1)
	EndIf
	Local $hicon=DllStructGetData($icon,1)
	Return $hicon
EndFunc
Func _GetFileExt($path)
	Local $erg=StringRegExp($path,"^.*\.(.*)$",3)
	If Not IsArray($erg) Then Return ""
	Return $erg[0]
EndFunc



;#################### Aero Extension: Elements, Styles, Max/Min/Clos/Other ##########################
Func _CreateBitmap($w,$h)
	Local $g=_GDIPlus_GraphicsCreateFromHDC(_WinAPI_GetDC(0))
	Local $b=_GDIPlus_BitmapCreateFromGraphics($w,$h,$g)
	_GDIPlus_GraphicsDispose($g)
	Return $b
EndFunc

Func _AeroUpdateRound($backgra) ; Style, mit runden Rndern
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	Local $clone=_GDIPlus_ImageClone($gui[4])
	Local $brush=_GDIPlus_TextureCreate($clone)
	_GDIPlus_GraphicsClear($gui[5],0x00000000)
	Local $size=DllStructCreate($tagSIZE,$gui[6])
	Local $w=DllStructGetData($size,1)
	Local $h=DllStructGetData($size,2)
	_GDIPlus_GraphicsFillRoundRect($backgra,0,0,$w,$h,30,$brush)
	_GDIPlus_ImageDispose($clone)
	_GDIPlus_BrushDispose($brush)
	_DrawonGUIT($gui)
EndFunc

Func _AeroStyleCreate($x,$y,$xx,$yy,$c1,$c2,$mode=0) ;mode: 0-both, 1-title, 2-under title, 3-both to one, 4-(both to one)three colors;Params:Width,Y_of_Color2,Y_of_Color3,Color(c)1,c2,c3,mode
	Local $style[3] ;Mode,Brush1,Brush2
	$style[0]=$mode
	If $mode=0 Then
		If Not IsArray($x) Or Not IsArray($y) Or Not IsArray($xx) Or Not IsArray($yy) Or Not IsArray($c1) Or Not IsArray($c2) Then
			Local $ret[1]=[0]
			Return SetError(1,0,$ret)
		EndIf
		$style[1]=_GDIPlus_LineBrushCreate($x[0],$y[0],$xx[0],$yy[0],$c1[0],$c2[0])
		$style[2]=_GDIPlus_LineBrushCreate($x[1],$y[1],$xx[1],$yy[1],$c1[1],$c2[1])
	ElseIf $mode=4 Then
		$style[1]=_GDIPlus_LineBrushCreate(0,0,0,$y,$yy,$c1)
		$style[2]=_GDIPlus_LineBrushCreate(0,$y,0,$xx,$c1,$c2)
		Local $bmp=_CreateBitmap($x,$xx)
		Local $g=_GDIPlus_ImageGetGraphicsContext($bmp)
		_GDIPlus_GraphicsFillRect($g,0,0,$x,$y,$style[1])
		_GDIPlus_GraphicsFillRect($g,0,$y,$x,$xx-$y,$style[2])
		_GDIPlus_GraphicsDispose($g)
		_GDIPlus_BrushDispose($style[1])
		_GDIPlus_BrushDispose($style[2])
		$style[1]=_GDIPlus_TextureCreate($bmp)
		_GDIPlus_BitmapDispose($bmp)
	Else
		If IsArray($x) And IsArray($y) And IsArray($xx) And IsArray($yy) And IsArray($c1) And IsArray($c2) Then
			$style[1]=_GDIPlus_LineBrushCreate($x[0],$y[0],$xx[0],$yy[0],$c1[0],$c2[0])
		Else
			$style[1]=_GDIPlus_LineBrushCreate($x,$y,$xx,$yy,$c1,$c2)
		EndIf
	EndIf
	Return $style
EndFunc

Func _AeroStyleDraw($backgra,$style)
	If Not IsArray($style) Then Return SetError(1,0,0)
	Local $num=__AeroGet($backgra)
	If $num=-1 Then Return
	Local $struct=$structs[$num]
	Local $gui=__AeroStructGetGUI($struct)
	Local $info=__AeroStructGetInfo($struct)
	Local $size=DllStructCreate($tagSIZE,$gui[6])
	Local $w=DllStructGetData($size,1)
	Local $h=DllStructGetData($size,2)
	;
	_GDIPlus_GraphicsClear($backgra,0x00000000)
	Switch $style[0] ;Mode
		Case 0
			_GDIPlus_GraphicsFillRect($backgra,0,0,$w,25,$style[1])
			_GDIPlus_GraphicsFillRect($backgra,0,25,$w,$h-25,$style[2])
			Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
			_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
			_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
			_GDIPlus_BrushDispose($brush)
			__AeroDrawWinButtons($backgra,$w,$h,$info,$gui)
		Case 1
			_GDIPlus_GraphicsFillRect($backgra,0,0,$w,25,$style[1])
			Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
			_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
			_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
			_GDIPlus_BrushDispose($brush)
			__AeroDrawWinButtons($backgra,$w,$h,$info,$gui)
		Case 2
			Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
			_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
			_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
			_GDIPlus_BrushDispose($brush)
			_GDIPlus_GraphicsFillRect($backgra,0,25,$w,$h-25,$style[1])
		Case 3,4
			_GDIPlus_GraphicsFillRect($backgra,0,0,$w,$h,$style[1])
			Local $brush=_GDIPlus_BrushCreateSolid("0xFF000000")
			_GDIPlus_GraphicsDrawImageRect($backgra,$info[0],10,5,16,16)
			_DrawStr($backgra,$info[1],30,5,$brush,12,1,"Arial")
			_GDIPlus_BrushDispose($brush)
			__AeroDrawWinButtons($backgra,$w,$h,$info,$gui)
	EndSwitch
	_AeroUpdate($backgra,$info[2])
EndFunc

Func _AeroStyleDelete($style)
	If Not IsArray($style) Then Return
	_GDIPlus_BrushDispose($style[1])
	_GDIPlus_BrushDispose($style[2])
EndFunc


;####################################################################################################
Func _Array2($var1,$var2)
	Local $ret[2]=[$var1,$var2]
	Return $ret
EndFunc


;################################# Images ################## Thanks to ProgAndy #####################
Func _IMG_Minimize()
	Local $tmp=''
	$tmp&='0x89504E470D0A1A0A0000000D494844520000002D000000C60802000000C9FB9E8C0000000674524E5300FF00FF00FF3758'
	$tmp&='1B7D000008D849444154789CED9B5B8C5D5519C7BFCB5EFB76CE744AB1506A53A00CB79200C6186C651EC0489B10122D0824'
	$tmp&='92107CA83EA92F064C243E189F8DD16830265E5E0811131363CAE589C40752A2251812B90C422965E8C581B99D7D59DFF7F9'
	$tmp&='70DA3ABBD5BDA7B3EB7437D9BFC92473CE9CB5D7EFECCBD96B7D67FDD1CCA003D0C5163845EF51A5F7A8D27B5409EAFF8D88'
	$tmp&='DEFB0BD21333AFDD030044A42CCB9612CEB97A8FAE1C97AE78341F17336B7F8A1035BCE1559D1F799EB7F40882868E56E531'
	$tmp&='1A8D5A7A8461D8D6A32CCB858585B39EFCF56FFFF0DEE1A335ADAEDEBEF5B147EF3FF3304DD3866EAC16003878F0E0B9ADEE'
	$tmp&='7F707F7DC3FB1FDCBFF2F5CF3FFF62FDEB9BF78702A4E9E4B9CFCFCCCCD4375CD90A19EB5FDCEC41C0575E79EDB9CF377EB8'
	$tmp&='AD6C454D1D357B042EBC66EA86A228563E29E2BFFF831FD7B412F15BB75FF39F8D04515B0F5FFA1B77DE323F7FF6A9DAC8D5'
	$tmp&='1B369DF99B5DBBEB258AA252FC6DB7EC7CEFF047E7EBB192384E5A79ECDAB5EBA95FFCF489EFFDF0F5370FCF9DF838CF656D'
	$tmp&='1E69DAE0818DF386E170B877EFDEEF3EFEC4F5533789EADA3C0060F3E51BEAFE5D7F598F999E9E6EFC606EA4BE8BE6FDB13E'
	$tmp&='74E5BEDF7B54E93DAAF41E557A8F2ABD4795DEA34AEF51A5C1E3EE7D8FC805A2BEA3865196181CFA70F1ED132346046206C4'
	$tmp&='801888091191100C9100CE0CA5C6934053F56A8AAA626A062A9F9E8C765FB371EDFB43759D466B0D1EA26B1CA09F2F4DC745'
	$tmp&='4CBC65B91022B322115B40A8CC844880086808680088606A606660A2A6AA20A62A6A2A62856F18E8377894DE9722992F0991'
	$tmp&='3C11139106C4C440A48888389E4023C078C46D662662A2A2634415B4F4EDE6735EB418EF0F02422241622652F68244448480'
	$tmp&='000078C643556DDCBF9989C8F86151B6BB5E0A91C2FBA5AC20442226426263C699979EFBF0F543350DB7ECBC7DC7F41E39BD'
	$tmp&='5372DF501C68F078F383B903AFBEFBB317FFC10E3908C220089C8B5DB8EBDD43CF3EF3544DC3071EFAC6D31F6F2E4B29A594'
	$tmp&='421EF8DCB5FB3EB36DED1E880848C448C0013221611058C4B08A3A0C06018B9AB261F3C776B30723051438A6808943C74940'
	$tmp&='830056518709060ECCD00C1988DBD52D99287294860111BAD051EC280D390D4F6CBBBEBE0E737CCB75711296DECCAC341FB6'
	$tmp&='AC9FBA308A4127D344C12876C120A4418C136EF6F3777F18DF63314940860808608066EC0532C591C2A888178A50D1238558'
	$tmp&='86CEB5F2180C262703DD72D9E09391A724E434C46102036703B698D5B1329A032300052A81C428106401623412233352E0A8'
	$tmp&='A5C78E1B6FFAE4E8DB77DD7CFBDF3E989F47B02486D4E1D049EA34648BD13B320643443314084AC5CC9005A96023D5C0803D'
	$tmp&='E671D8E0D15C77D87EE7971FFACA7D3B6EBE6DE30DD7E621975130723CEFE839071F312D136488394209E00C22B3582D15BB'
	$tmp&='D2DBDE522773090B894662B93C76EB15AD3C00E0CE6FFDE4FD77DEC8168F9363081963B6808C11183520A3D3E7871A790531'
	$tmp&='14C3522D1728444B81A25485E32FFFB1ADC73A70898C0BD78DDEA34AEF51A5F7A8D27B54E93DAAF41E552E118FBBEEDDD789'
	$tmp&='3A8C177DE9B577FEFECF592460264622046462223A3DC9A6D35F55ABC1F8474D45D4D4BC8DE7BA76DD5597DF7BC7CEB5EF8F'
	$tmp&='A2E97D5C289A3C8A0BB348A99186E392957E54949F2C8F88908998904E4DFB9181687C4870FC6BE33299AA89A998A9A88C2B'
	$tmp&='646ACB7951DB4FA347E197F3726E714488CCCC044414308D9D1009CE3A3F0C145444D56C5C741031515DCCDAD51DB2A25CCE'
	$tmp&='CAB9C5650666466664A68088889818E98C040298029801A8791551135111F56A26B6346A58D9D3541FCB4B9FE5C5FC321222'
	$tmp&='113987116318E4336F94EF1FAE69E8AED81A6E9D32F1E3D2906FE97172F6C85F0F1EFCFDD37F22628A234A131CA4384CF624'
	$tmp&='D65887F9F35F5E95A25011F5227BBEF09D87BFB8760F0044442422660C2348221824304841971AEB301087A462AA4804D86E'
	$tmp&='3D0C22213191C328A438C238852485E100E6971AEB3018C5E815C40094A8DD7A18220A5D18C5B1C5312629A6290C06B07170'
	$tmp&='24DA545F87390A411027EA15BD210A734B0F178661900C87850B2949301DC08609DB38786BC7963727429D8C2C7140086A38'
	$tmp&='2A69BEA0A502FF35A2E38B706221C817C0AB0A485172CBFA47940C26D268D3659B4E9642F110D2214CA43031A11B12988874'
	$tmp&='43AC310131A89053820CD161C994016606859A37F5C8540641BB3AEEF61D530B73C7A6EFB8F5E0DB473F0696610AC3810D13'
	$tmp&='1BC4368C6D185BC816207AC340501095B8441C2964024B0AB9586C82CC41EB3ACCA7A63EFBF057F76D9BBA79E38D53C530F2'
	$tmp&='1349318817E3F085908F059C136544256089E8CC42D5C84B5CF82BB2E29EC57CB890B9A5655ECA20CBBE7DDF742B0F00B8E5'
	$tmp&='4B5F9B3DFCDEA64D832089398A3189218E66E3A88C62089D39072E00661081B284A2B42277597E5596C328932C976C247931'
	$tmp&='F3F20B6D3DD6814B645CB86EF41E557A8F2ABD4795DEA34AEF51A5F7A8D2158FBA71A1991191B65893BC12AC9DC2AC6AD571'
	$tmp&='FD265643E368AB2BC7A5F7A8D27B5459E32AFD071EDA3FAE8BFD6FECD9677EF97FF700C0C63ACC796D6EEDA985E63ACCFA78'
	$tmp&='B40F5D5E100FABAFC3AC5873B82AEAE6B7E3FBCBB163C7366FDE7C5E1BFDAF9BAABF39345CB751149D3C79B2A5C46AA8F340'
	$tmp&='C4DDBB771F3870005671A36A4B4D464755676666D2347DF2C9275F79E5153BF525C61AA9CF0335C4858E1C39323737373D3D'
	$tmp&='ED9A0A6D6DDEB0AD269774A18E48FD79DAD783AAF41E557A8F2ABD4795DEA34AEF51A5F7A8722978BCB56C9DC82579EB462E'
	$tmp&='493B924B12EB462EC93A924B52EB462EC9FA5CD2D9F4B9A4951BEA482E89B01BB924EC482E89B11BB9A405E9462EE937B3BA'
	$tmp&='6DE9D8D71FFDE6C5CF25FDFC9DA5DB06F0F88F7E75F17349BF9BD59D29260C6260A716DD9E1A709CDB144F2F044580B11E23'
	$tmp&='104080707DDAD761564FEF51A5F7A8D27B54E93DAAF41E557A8F2A9782C75BCBD6895C92B76EE492B423B924B16EE492AC23'
	$tmp&='B924B56EE492ACCF259D4D9F4B5AA9D0915C1261377249D8915C12633772490BD28D5CD2B80EF3F09E7B2F7E2E695C87D9FF'
	$tmp&='C8FE8B9F4BEAEB301783DEA34AEF51A52B1EFF060D0D809AC29133D90000000049454E44AE426082'
	Return $tmp
EndFunc


Func _IMG_Close()
	Local $tmp=''
	$tmp&='0x89504E470D0A1A0A0000000D494844520000003C000000C608020000000197745A0000000674524E5300FF00FF00FF3758'
	$tmp&='1B7D0000100649444154789CED9D6D8C5CD579C7FFCFF39C73E7CEFBAEB14D31C5E037C04B080435ADA9DD068848AA2A559B'
	$tmp&='D6B5EB8808B554500AFD80142555445585A2484991F8501ADA4869AA2AC5C5E5438214A242251A8853B5B6D3908D5F423032'
	$tmp&='18D3D8CE0BC1EBF5CEDC739EA71FCECC32259E219E6C66176BFE1AADEE9EBDF7DCDF9C79EE39F7FECF9967C9CCF076132F36'
	$tmp&='C0301A438F4A63E851690C3D2AF585FECC5DB7C5C5D387DE77D30068D7EF0F16C3ECA1E9D7BFF50D004220800041DA304720'
	$tmp&='800106888D018252FFD3186060054CC9000362FA69309002DAD907D1505B7FA5691C0E3A42D58A368098F808112600A00A30'
	$tmp&='A0040200538019838756D5B403A50ACD3A940A56408DAC8B1E4311E3A0CAFA4387A03186F61C00010C008160063820120030'
	$tmp&='100101003C347D6CF7ABA7D2B15B56D5EFBA7AD5DF4EBFFAB59E923FB9FAE22EE51B2D6D36BF41B15B8E184CC330D05AB462'
	$tmp&='511467E618302811AC1B2101962241A9F37E04D8FDEAA9C71EFDFB74ECD6ED77583CBAFBF86C6FC9EDEB67D347AEDD968E9D'
	$tmp&='F740B15B08838243D1D6385C78B40B0B453C33A39D384E1FAE2574472800E10EB101D75F906DDD7EC7AE9D0F03D8B5F3E16D'
	$tmp&='3BEEDCB5F3615505B06DC79DD75F90C5B9D914BB1D688502D1BABF8252DB1AA045118B6218E8D06E8576D13A3D2B00110850'
	$tmp&='74C283012330600CEEBE8D3FBA881179DB8E3B777EE121003BBFF0508C11C08E5BEEBE7E82FFF8222E664FBF1115A0D08536'
	$tmp&='20F4421BC25C5BC370E1D19AD3A2DD3E350340180C08816101708090322080004A963E8A5B27A04176DC72F767FEE6AF5225'
	$tmp&='7FFA677FF12B35BD75A268CDB4BA9D03752913348714E5D60D1245B57D2616ED61A07FB077F7F70F7EFBC0AE7FE26E3C3806'
	$tmp&='C31CC1C33CD45307DA9109C00C0266D7BC07CB36F4D633FBF2E1635FFDAA01A608801A452000110886002E40C1109542B7E1'
	$tmp&='D7F9ECE40BDF1900DD7F44242622160FF1E21C3947EC581CB183137807EFC83BF60ECEC37B88FBE2DA1BA7976D78F0817B5B'
	$tmp&='5D3DF8C0BDD3CB367C71ED8D1007EFC97BF22E1D0BE7E01C58C00EECC839724E9C837811010D1AAAFBFECD44E01D5572A9E6'
	$tmp&='542973B94C9532977329E7949751AA20AF20AF68B9827219E5F297D6DE303DB9EE539FFC68BBDD6EB7DBF77CE4FEB4F1A94F'
	$tmp&='7E747A72DD97D6DE8072D9CA652B5750AE705EA17285F20A2A6529E752C9A952A672992A65A9E69479F050D0E432F299ABD5'
	$tmp&='A45A73D51AD76AAE5EA37A83EA0DD76848A32EB53A35EBD2ACA35943A336DDB8ECFE4FDC53144551141FFBF8A7AF3EF3CAC7'
	$tmp&='3EFEE9F4EBFD9FB867BA71191A356AD4B859A7469DEA75AAD5A95177F506D71B5C6FB86A2DBDA45AA33C67EE1BB71810D3E2'
	$tmp&='7329E7BE3941046110E00942C6802370BA341904F33010DE194FDEFB970FA663AF89277F978E722CCD97BC339EE4C9493204'
	$tmp&='900382913340A1D6ED4F8DC860806727B5BAF3D930D094957CA952BE60390148971AE0247523E6084C706C4C9D3B93AD786D'
	$tmp&='3B5EEBA960F936BCB6AD5B6240C47200894C2245834BD7A29128A2418008F86A33D6271AD5CA30D0AE94715ECA9ACB844030'
	$tmp&='223828091CC0640E104122661811A43B4CF65300CC4880083245549881016F140CAA50E75CB9D158BF71CFB1E353EBD70D03'
	$tmp&='5D2E65CBD65E4EEFFF0003844E4FCC02EA8E358E0CDD1B4060F0E50E00D0EE1D52F756291AA5DBA6085804B2EC7BA7DBBBF7'
	$tmp&='1F7CFC5F777DF9D0E10135513FDFE3D6B52B7FD41DFF890022068188084404660277CA090402D1FCBE6FD4383FFA77B1CD60'
	$tmp&='F3024CD5CCD4CC4C01ACACE457ACBEE4CFBFF2ECE0B7DF177A29EBFC7ADC5ACA1A438F4A63E851690C3D2A8DA147A531F4A8'
	$tmp&='34861E95CE2FE89BAEBD7A114DF55B6FBE710074FF2775B333DFDA7B6ACF6E006C20021308C61DAFDA9808C966274A4E3BF5'
	$tmp&='7F483483810C80D9BC85AE30D3AEA36EA4801994505E7F25548769691B78D8CF5B43CE0460E0613FA97F3870FCA9A33F4EDB'
	$tmp&='37AF6EDE3675E1E70E1C7FEAE56EC925CD3F9CFA859FBE361BCE9FD6A85684383B4B208325539D094630980146C4D4F17F09'
	$tmp&='78EAE88FFF9FA91EC2BFBF7ABAB7E4D635F564F2761EBFD5AC63579359C77A4C51A4AD960D67F542A386769C9D0111753D69'
	$tmp&='85719AC548732D0483111103EF5D39C8547FEFCACCCECC46203D842B480D6AF3F301A629A653ACB7E78684B618B4DD2E4ECF'
	$tmp&='1088C914C404A64EBDDCB53F92F364C08757C0C2D94DF59B96F18757209C3EDD9D703105A94261C9038966C99F064C8DE25C'
	$tmp&='4BC35033011A622CDAC5CCA984C7449CCC24C011882C828460202603C0C02D75B2C2BDC954BFB11E6FA9B7E28C757A0C4BE1'
	$tmp&='6166099AD20C86699A28323384D6191D6EFAE2F5E3FFFBBD8307BEF9D8BFA40E4E088E92850E8139320F08C103C29626EC18'
	$tmp&='38B5FA57B162AAB79E532F7EE7A5FFF87A329622A04A91100C854181601441C192C10E35A8D1EA60275F7C6100747FAB9788'
	$tmp&='98D8317B662FE285BDB06776E925EC859D906772424E58F8894B37EF5D31F526537DEF8AA9272EDD4CC2E4449C50C6D43D9C'
	$tmp&='9C90633826CF9CBD710A12221E640CF6876666272ECF5C2973B997DC4BEE5D9E49D9BBB27715CF15C75547554F55CF35FFC4'
	$tmp&='9ACD7B966F3CABA9BE67F9C627D66CE69A43DAB9E2B9E2A4EC5CAAAAEC5D9EB9DC73EE5DEE5D2913EF5864286847E2A554CD'
	$tmp&='4AB52CAB65592DF3B5CC3532DF2C493377E93591BB895C969578A2B4A77945AFA9FECBAD177A4DF53DCD2B78B2249325992C'
	$tmp&='A5A3FC44A712DF2865F5CCD7B2BC9665B5AC54CB7CEED90FBA29EA6FAA3B7165974F9699013621084308CC70026613020B1C'
	$tmp&='41184CD86447E62DF44D7CE4776A8738BADE92ECC28A1A45851A58C10A51B84851110C4E910C5F62EFEA955269A89900F6E2'
	$tmp&='735F9DAC4240644C8915E2C064EC200C96F4368C857E9F8F6CC3919E0A6ADBF0468901B09A46532555444550984203CC2804'
	$tmp&='A4423548A519EB8D896679A896F6E2729F4F5688C0622C6031F620B134BF4559776ACA13B1B1A451A89F4CA3A9C20269808B'
	$tmp&='F0053420066824176011AA8EF366F992A9BD3F3A35B5F1CAA1A09DD42EBD7CF56FFC36392301B3B15378B007326331788303'
	$tmp&='3B400C0C38800DE82EA8484AB77000949026370359840542300B6C81AC80B5A19140F9B1D76CF7FE579EFCCAE3FFFCDF4706'
	$tmp&='40F7F5A7A72EAC5E7B510D000844060633C0202612101B49DA48854816FB00999A75C615580414A6B0088B9D3F99D2C5F5D2'
	$tmp&='15975D7ADBE7C7A6FA12D1187A541A438F4A63E851690C3D2A8DA147A531F4A834861E95FA427F68DB0717D154BF79F37503'
	$tmp&='A00799EADFDDFBECFEAF3F49803009737A3961261611616661216611024484D262A1E4B2769636216D5B7721508CD1008D31'
	$tmp&='9A6AD4A81A6354D390B655A3EAEA77BC7BF052E4256AAA0FBBAAF71CA19FF89F63FB5EFC61DAFEA575CB3E70DD255FFEC62B'
	$tmp&='7B0EFF60BEE437DFF58B3F7D6D1A865AD56B21C4A2DD9A39C580108BB063566665E6B42D22C2CACCCC4CB4EFC51FBEC954DF'
	$tmp&='F7D2EBBD25EFBBBCA906D5A866AAAAAA316A8C31A86AD4A0AAAA2115CECD85F650D0AA1ADAEDD6E919019859985444884444'
	$tmp&='984C4499954598588489AE5D950F30D5DFB52A2F4ECF184CA3AA590AE4A05155438C512DC618CD8A18A35AD16E0DB97E5A63'
	$tmp&='0CA1DD9E9921826372CC26CCC44EC4A537C0EC4422913861C27B2E122DE4ACA6FA352BDD0D1773313B6366AA510D3144350B'
	$tmp&='31A60B31A885EEE5185443AB15876DE910DBEDB9D3334C88C421D9BCC2CA1C93D9EB445998D93183C809FFDA72D2406F32D5'
	$tmp&='DF3169BFBE2214A78BB47E304485590A86A8B108B1D369440DAA45DA68B7427B28537DEFD79E7DFEE6F73FFED8BF39A00464'
	$tmp&='400678820732330764802378EE2C3A7502269CD8B019ABAEEAADE7C4FE03FFF5F86E3398410D452433C48842118036500045'
	$tmp&='DAB0CEAFEDDAEA13DF3F35007AC04A750211A7BEB7337941D4DD00131C2123943A2FCAE9E52BB79C5875D59B4CF513ABAE7A'
	$tmp&='E98A2D9413E5849CA804946025204BEB81697E7264BEF2CECAD021A0898999D2A042C21066E134CC50C6A830AA4C55B60AA1'
	$tmp&='4AA8E2E50D9B4F5C38755653FDF8CAA923EB376B8550215419554685A94AA8122A441951AA76FEC5F32B57CFB5A58541C48E'
	$tmp&='C9B10893639498CA8C1AA3CE5C636E3035194D4683A9C1272F98EA35D557CE1CEC35D54F2C9B4253D01434188DB4215417AE'
	$tmp&='09D505354699A9C4E4D2C02B83D708F75FF42D22CCDE3B61884004E2E104E220CE4400013B889808986D65EBF9790BFDC2F6'
	$tmp&='F36BEC9B54B8DE1269666666D148A10150C4008EE00817C8022C42DA00799F979C0C3513C08E39273729893893F40D0B3807'
	$tmp&='71C602E7D39B6171C2446B65FF3A3A404444649951BDBA1E07D7E3A099A512AB56CDCC62244BBD9DB9000BD0004458018BB0'
	$tmp&='02B5DA44B6AC516FFAE15A9AB944BEC9C29D2F788823E7E03C84CDF9F4050FE12E348B70BA6C891268AAA7036D6666AA265D'
	$tmp&='688A6A216A112D1822690126DFA84CAED9B8E9E4CCA93553D70CD5D2C2EB375EBB75DBF6CC5996A1E42DF3963978AF4EA273'
	$tmp&='D14B1029440AC76D9696708BB9606E31B5990AE20020C6B25A66568A31532B69CC8266316631FA105D88128214918BC25A05'
	$tmp&='A96533736EFF317BE41F1FF9F6E163C340AF9E5CFE5B1FFCBD150D4F143C8359BD44E7E0185E3A5FCF11866773DEC4991378'
	$tmp&='86A5E8EF06645458040C515114A4918221440E0121A01D49A3B52362A0B6B2469E98AC5526D70D26C6D8541F9DC6D0A3D218'
	$tmp&='7A541A438F4A63E851690C3D2A8DA147A531F4A8D4FF718BE85C8DD3051433AB6A3FF763D04A32E02D4C939F93DEF2B9E4FC'
	$tmp&='0A8F73D5D6EDB703F31F8B3DF6E8677FB264A1CEB560D000F55AE889B8B764E14EB490E1615BB7DF912CFE5D3B1F062899EA'
	$tmp&='AABA75FB1DBDDF25FFD9D5F7693CF51EE77421A6D64DA6FABC76DC72F7B9C686990DEE3D16121A5DEE5E537D88687E4BE8B7'
	$tmp&='65EFB1F0E1F1E003F7F616DEF391FB173C3C16ACA513F1594D7580B66EBF7DA14E84050D0FEA35D501EB35D57B3AEC8538D3'
	$tmp&='4285C7020E2E67CE9CA9542AA3EB3D7E7699D9E1C387A7A6A65AADD6DBA3F7482DF8CC33CF6CD9B265C06E8386F1E4E02F30'
	$tmp&='D7C0D3EDDBB7EFE9A79FBEEFBEFB9E7BEEB9017BBE05F44283BD85BCF79B366D3A7AF4E8DCDCDC80B3F76DCB4534DB0F1D3A'
	$tmp&='B471E3C6013B8C670246A531F4A834861E95C6D0A3D2187A541A438F4A63E851E9FC825EF4F42F7AE4503FB6259CFE25F65D'
	$tmp&='F7BD4457AA9B46F45F61BF74D3BF0C485BB384D3BF58DF8F7A09A77FD1BE0FAF4B39FDCBB9438FD3BF8CD3BF2CEDF42F7DB9'
	$tmp&='9770FA97FE8DBD84D3BFF45F62BF74D3BF10F74D10B484D3BFF4FF57014B34FDCB5F3FF0777A600FAFBFFAAC6C4B31FDCBB6'
	$tmp&='BBEEC70BD3F53FB8BB5F557DA1F5E5EF42236240BAE132851ABA374BDD2176686F9BBA3FD2F770D2DD3A130B980FBF3EB7E1'
	$tmp&='BA770F3A786CAA8F4863E851690C3D2A8DA147A531F4A834861E95C6D0A3D2F905BDE8E95F8634D51739FDCBDBCE54D71086'
	$tmp&='31D5173DFDCB30A6FAE2A77F19C2545FFCF42F4398EA4B20FDCB10D0E3F42FE3F42F4B3AFDCBB99BEA8B9FFE6508537DF1D3'
	$tmp&='BF0C63AA2F76FA97614CF5C54FFF3284A9BEB8E95F9EFCFCE70698EA4B31FDCB7F3EFA085E987663537DF1757E3D232E658D'
	$tmp&='A147A531F4A8F47FE933B834BFA1695A0000000049454E44AE426082'
	Return $tmp
EndFunc






Func _LoadImage($funcname)
	Local $bin=Call($funcname)
	Local $img=_LoadImageFromBinary($bin)
	Return $img
EndFunc



;Authors: Prog@ndy, Zedna
Func _LoadImageFromMemory($Pointer, $nSize)
    Local $hData, $pData, $pStream, $pBitmap, $hBitmap
        ; use GDI+ for converting to bitmap first
    $hData = _MemGlobalAlloc($nSize,2)
    $pData = _MemGlobalLock($hData)
    _MemMoveMemory($Pointer,$pData,$nSize)
    _MemGlobalUnlock($hData)
    $pStream = DllCall( "ole32.dll","int","CreateStreamOnHGlobal", "int",$hData, "long",1, "Int*",0)
    $pStream = $pStream[3]
    _GDIPlus_Startup()
    $pBitmap = DllCall($ghGDIPDll,"int","GdipCreateBitmapFromStream", "ptr",$pStream, "int*",0)
    $pBitmap = $pBitmap[2]
	Return $pBitmap
EndFunc


;Authors: Prog@ndy, based on code by Zedna
Func _LoadImageFromBinary(ByRef $Binary)
    Local $picdata = Binary($Binary) ; Fetch the Data
    Local $piclength = BinaryLen($picdata) ; Get Length

    Local $picstruct = DllStructCreate("byte[" & $piclength & "]")

        DllStructSetData($picstruct,1,$picdata)
        Local $picmemory = DllStructGetPtr($picstruct)
        Local $hImage = _LoadImageFromMemory($picmemory, $piclength)
        DllStructSetData($picstruct,1,0)
    $picstruct = ""
    Return $hImage
EndFunc
;####################################################################################################


